#!/usr/bin/env node
'use strict';

var _templateObject = _taggedTemplateLiteral(['\n          ', '\n          ', '\n            $ cd ', '\n            $ motion\n        '], ['\n          ', '\n          ', '\n            $ cd ', '\n            $ motion\n        ']),
    _templateObject2 = _taggedTemplateLiteral(['\n          ', '\n          To access the built files, do\n            $ cd ', '\n        '], ['\n          ', '\n          To access the built files, do\n            $ cd ', '\n        ']),
    _templateObject3 = _taggedTemplateLiteral(['\n          ', '\n          ', '\n            $ motion\n        '], ['\n          ', '\n          ', '\n            $ motion\n        ']);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _coolTrim = require('cool-trim');

var _coolTrim2 = _interopRequireDefault(_coolTrim);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _package = require('../../package.json');

var _package2 = _interopRequireDefault(_package);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

require('process-bootstrap')('motion');

var currentDirectory = process.cwd();

_commander2.default.version(_package2.default.version);

_commander2.default.command('new [name]').description('Create a new motion app with the given name').action(function (name) {
  (0, _helpers.getMotion)(_path2.default.join(currentDirectory, name), function (motion) {
    return motion.init().then(function () {
      console.log((0, _coolTrim2.default)(_templateObject, _chalk2.default.green('App created successfully! Enjoy'), _chalk2.default.yellow('To run motion in your new app, do'), name));
    });
  });
});
_commander2.default.command('build').description('Build dist files of the current motion app').action(function () {
  (0, _helpers.getMotion)(currentDirectory, function (motion) {
    return motion.build(process.stdout.isTTY).then(function () {
      console.log((0, _coolTrim2.default)(_templateObject2, _chalk2.default.green('App built successfully'), _path2.default.relative(currentDirectory, motion.config.getPublicDirectory())));
    });
  });
});
_commander2.default.command('watch', null, { isDefault: true }).action(function () {
  (0, _helpers.getMotion)(currentDirectory, function (motion) {
    return motion.watch(process.stdout.isTTY);
  });
});
_commander2.default.command('init').description('Try to transition current directory to a motion app').action(function () {
  (0, _helpers.getMotion)(currentDirectory, function (motion) {
    return motion.init().then(function () {
      console.log((0, _coolTrim2.default)(_templateObject3, _chalk2.default.green('Motion initialized successfully! Enjoy'), _chalk2.default.yellow('To run motion in your new app, do')));
    });
  });
});

_commander2.default.parse(process.argv);

if (!_commander2.default.args.length) {
  // Execute default watch command
  (0, _helpers.getMotion)(currentDirectory, function (motion) {
    return motion.watch(process.stdout.isTTY);
  });
}
//# sourceMappingURL=index.js.map